/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import BitBuffer from "./BitBuffer";
import Slice from "./Slice";
import { Buffer } from "./Buffer";
import { FilterPolicy } from "./Options";
/**
 * time of hash is main effect
 * best time of hash = bits number / elements number x ln2(≈0.69)
 * elements number and ln2 is predictable
 * bits number is configable
 * from past experience, bitsPerKey = 10 is best
 */
export default class BloomFilter implements FilterPolicy {
    constructor(buffer?: Buffer, bitsPerKey?: number);
    private _buffer;
    private _offset;
    private _size;
    private _kNumber;
    private _bitBuffer;
    private _bitsPerKey;
    get bitsPerKey(): number;
    get bitBuffer(): BitBuffer;
    get buffer(): Buffer;
    get size(): number;
    get kNumber(): number;
    name(): string;
    putKeys(keys: Slice[], n: number): void;
    keyMayMatch(key: Slice, bloomFilter: Slice): boolean;
}
