export declare class Buffer extends Uint8Array {
    static kMaxLength: number;
    static checkInt(buf: Buffer, value: number, offset: number, ext: number, max: number, min: number): void;
    static checkBigInt(value: bigint, min: bigint, max: bigint, buf: Buffer, offset: number, byteLength: number): void;
    static checkOffset(offset: number, ext: number, length: number): void;
    static createBuffer(length: number): Buffer;
    static isBuffer(obj: unknown): obj is Buffer;
    static checked(length: number): number;
    static fromArrayLike(arr: number[]): Buffer;
    static fromString(str: string): Buffer;
    static fromHex(hexString: string): Buffer;
    static fromArrayBuffer(array: ArrayBuffer): Buffer;
    static fromUnknown(value: string | Uint8Array | Buffer | ArrayBuffer | {
        length: number;
    }): Buffer;
    static compare(a: Buffer, b: Buffer): 0 | -1 | 1;
    static isArrayBuffer(value: unknown): value is ArrayBuffer;
    static assertSize(size: number): void;
    static alloc(size: number): Buffer;
    static allocUnsafe(size: number): Buffer;
    static concat(list: Buffer[], length?: number): Buffer;
    copy(target: Buffer, targetStart?: number, start?: number, end?: number): number;
    fillBuffer(val: Buffer, start?: number, end?: number): Buffer;
    fillInt(val: number, start?: number, end?: number): Buffer;
    slice(start?: number, end?: number): Buffer;
    readUInt8(offset?: number, noAssert?: boolean): number;
    readUInt16BE(offset?: number, noAssert?: boolean): number;
    readUInt32BE(offset?: number, noAssert?: boolean): number;
    readUInt32LE(offset?: number, noAssert?: boolean): number;
    readBigUInt64LE(offset?: number): bigint;
    readBigInt64LE(offset?: number): bigint;
    writeUInt32LE(value: number, offset: number, noAssert?: boolean): number;
    writeInt32BE(value: number, offset: number, noAssert?: boolean): number;
    writeBigUInt64LE(value: bigint, offset?: number): number;
    private internalWriteBigUInt64LE;
}
