/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { DatabaseOptions } from "./Options";
import { SequenceNumber } from "./Format";
import { FileMetaData } from "./VersionFormat";
declare type TableInfo = {
    meta: FileMetaData;
    maxSequence: SequenceNumber;
};
export declare class InternalDBRepairer {
    constructor(dbpath: string, originalOptions: DatabaseOptions);
    private _env;
    private _icmp;
    private _manifests;
    private _logs;
    private _tables;
    private _tableInfos;
    private _dbpath;
    private _options;
    private _nextFileNumber;
    private _tableCache;
    private _edit;
    run(): Promise<void | Error>;
    findFiles(): Promise<void | Error>;
    convertLogFilesToTables(): Promise<void>;
    convertLogToTable(logNumber: number): Promise<void>;
    archiveFile(filename: string): Promise<void>;
    extractMetaData(): Promise<void>;
    scanTable(tableNumber: number): Promise<void>;
    repairTable(srcTableFilename: string, tableInfo: TableInfo): Promise<void | Error>;
    writeDescriptor(): Promise<void | Error>;
}
export {};
