/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { FileType } from "./Format";
import { Env } from "./Env";
export declare function getCurrentFilename(dbpath: string): string;
export declare function getLogFilename(dbpath: string, logNumber: number): string;
export declare function getTableFilename(dbpath: string, tableNumber: number): string;
export declare function getManifestFilename(dbpath: string, manifestNumber: number): string;
export declare function getLockFilename(dbpath: string): string;
export declare function getInfoLogFilename(dbpath: string): string;
export declare function getOldInfoLogFilename(dbpath: string): string;
export declare function getTempFilename(dbpath: string, number: number): string;
declare type InternalFile = {
    isInternalFile: boolean;
    filename: string;
    number: number;
    type: FileType;
};
export declare function parseFilename(filename: string): InternalFile;
export declare function setCurrentFile(env: Env, dbpath: string, manifestNumber: number): Promise<void | Error>;
export {};
