/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { SequenceNumber, ValueType, InternalKeyComparator, LookupKey, Entry, EntryRequireType } from "./Format";
import Slice from "./Slice";
export default class MemTable {
    static getValueSlice(key: Slice): Slice | null;
    static getEntryFromMemTableKey(key: Slice): Entry;
    private _immutable;
    private _list;
    private _size;
    refs: number;
    internalKeyComparator: InternalKeyComparator;
    constructor(internalKeyComparator: InternalKeyComparator);
    keyComparator: (a: Slice, b: Slice) => number;
    ref(): void;
    unref(): void;
    get size(): number;
    get immutable(): boolean;
    set immutable(next: boolean);
    add(sequence: SequenceNumber, valueType: ValueType, key: Slice, value?: Slice): void;
    get(key: LookupKey): EntryRequireType | void;
    iterator(reverse?: boolean): IterableIterator<Entry>;
}
