/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { FileHandle } from "./Env";
import Slice from "./Slice";
import DataBlock from "./SSTableBlock";
import { BlockContents, BlockHandle, Entry } from "./Format";
import Status from "./Status";
import { Options, ReadOptions } from "./Options";
export default class SSTable {
    static readBlock(file: FileHandle, options: ReadOptions, handle: BlockHandle): Promise<BlockContents>;
    static open(options: Options, file: FileHandle): Promise<SSTable>;
    constructor(rep: {
        file: FileHandle;
        options: Options;
        indexBlock: DataBlock;
        metaIndexHandle: BlockHandle;
    });
    private _file;
    private _cacheId;
    private _options;
    private _indexBlock;
    private _filterReader;
    private readMeta;
    private readFilter;
    get(target: Slice): Promise<Status>;
    entryIterator(reverse?: boolean): AsyncIterableIterator<Entry>;
    blockIterator(table: SSTable, options: Options, handle: BlockHandle, reverse?: boolean, blockType?: string): AsyncIterableIterator<Entry>;
}
