/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Comparator } from "./Comparator";
import { BlockContents, Entry } from "./Format";
import Slice from "./Slice";
import { Buffer } from "./Buffer";
interface RestartedEntry {
    entry: Entry;
    shared: number;
    nonShared: number;
    rawSize: number;
}
export default class SSTableBlock {
    constructor(contents: BlockContents);
    blockType: string;
    private _restartPoint;
    private _size;
    private _buffer;
    get buffer(): Buffer;
    get size(): number;
    getNumRestarts(): number;
    decodeEntry(offset: number, lastKey: Slice): RestartedEntry;
    restartPointIterator(reverse?: boolean): IterableIterator<number>;
    iterator(comparator: Comparator, reverse?: boolean): IterableIterator<Entry>;
}
export {};
