/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Buffer } from "./Buffer";
import Slice from "./Slice";
import { FileHandle } from "./Env";
import { Options } from "./Options";
import { BlockHandle, CompressionTypes } from "./Format";
export default class SSTableBuilder {
    constructor(options: Options, file: FileHandle);
    private _closed;
    private _numberOfEntries;
    private _options;
    private _file;
    private _fileSize;
    private _lastKey;
    private _dataBlock;
    private _metaBlock;
    private _indexBlock;
    private _footer;
    private _offset;
    private _pendingIndexEntry;
    private _pendingHandle;
    add(key: Slice, value: Slice): Promise<void>;
    get numEntries(): number;
    get fileSize(): number;
    flush(): Promise<void>;
    writeBlock(block: BlockBuilder, handle: BlockHandle): Promise<void>;
    writeRawBlock(blockContent: Slice, type: CompressionTypes, handle: BlockHandle): Promise<void>;
    appendFile(buffer: Buffer): Promise<void>;
    close(): Promise<void>;
    abandon(): Promise<void>;
    finish(): Promise<void>;
}
declare class BlockBuilder {
    constructor(options: Options);
    blockType: string;
    private _options;
    private _buffer;
    private _restarts;
    private _finished;
    private _counter;
    private _lastKey;
    get buffer(): Buffer;
    reset(): void;
    add(key: Slice, value: Slice): void;
    isEmpty(): boolean;
    finish(): Slice;
    currentSizeEstimate(): number;
}
export {};
