/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import Status from "./Status";
import { FileHandle, Env } from "./Env";
import Table from "./SSTable";
import { Options, ReadOptions } from "./Options";
import Slice from "./Slice";
import { Entry } from "./Format";
import Cache from "./Cache";
export interface TableAndFile {
    file: FileHandle;
    table: Table;
}
export declare class TableCache {
    constructor(dbpath: string, options: Options, entries: number);
    _destroyed: boolean;
    _env: Env;
    _dbpath: string;
    _options: Options;
    _cache: Cache<number, TableAndFile>;
    destroy(): Promise<void>;
    get(options: ReadOptions, fileNumber: number, fileSize: number, key: Slice, arg: unknown, // state.saver, set kNotFound if not found
    saveValue: (arg: unknown, key: Slice, value: Slice) => void): Promise<Status>;
    findTable(fileNumber: number, fileSize: number): Promise<Status>;
    entryIterator(options: ReadOptions, fileNumber: number, fileSize: number): AsyncIterableIterator<Entry>;
}
