/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Buffer } from "./Buffer";
import { BlockHandle } from "./Format";
/**
 * fill in end of table, fixed 48 bytes，
 * include offset, size of data index block and meta index block
 *
 * read sstable from footer
 */
export default class TableFooter {
    static kEncodedLength: number;
    constructor(buffer: Buffer);
    _buffer: Buffer;
    get indexHandle(): BlockHandle;
    get metaIndexHandle(): BlockHandle;
    get buffer(): Buffer;
    set metaIndexOffset(value: number);
    set metaIndexSize(value: number);
    set indexOffset(value: number);
    set indexSize(value: number);
    get(): {
        metaIndexOffset: number;
        metaIndexSize: number;
        indexOffset: number;
        indexSize: number;
    };
    put(data: {
        metaIndexOffset: number;
        metaIndexSize: number;
        indexOffset: number;
        indexSize: number;
    }): void;
}
