/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import Slice from "./Slice";
import SkiplistNode from "./SkiplistNode";
export default class Skiplist {
    constructor(keyComparator: (a: Slice, b: Slice) => number, maxsize?: number);
    keyComparator: (a: Slice, b: Slice) => number;
    maxsize: number;
    level: number;
    head: SkiplistNode;
    private isKeyAfterNode;
    private generateNodeLevel;
    private findGreaterOrEqual;
    private findLast;
    private findLessThan;
    iterator(reverse?: boolean): IterableIterator<Slice>;
    private isEqual;
    seek(key: Slice): SkiplistNode;
    put(key: Slice): void;
}
