"use strict";

exports.__esModule = true;
exports.default = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
class SkiplistNode {
  constructor(maxlevel, key, next) {
    _defineProperty(this, "key", void 0);

    _defineProperty(this, "maxlevel", void 0);

    _defineProperty(this, "levels", void 0);

    this.key = key;
    this.maxlevel = maxlevel;
    this.levels = new Array(maxlevel + 1);
    if (!!next) this.fill(next);
  }

  /**
   * link every level in this node to next
   */
  fill(next) {
    for (let i = 0; i <= this.maxlevel; i++) {
      this.levels[i] = next;
    }
  }

  next(level) {
    return this.levels[level];
  }

}

exports.default = SkiplistNode;
//# sourceMappingURL=SkiplistNode.js.map