/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
declare enum Code {
    kOk = 0,
    kNotFound = 1,
    kCorruption = 2,
    kNotSupported = 3,
    kInvalidArgument = 4,
    kIOError = 5
}
export declare class StatusError extends Error {
    _code: Code;
    constructor(code: Code, message?: string);
}
export default class Status {
    static createNotFound(message?: string): Status;
    static createCorruption(message?: string): Status;
    private _error;
    private _promise;
    private _code;
    private _finish;
    constructor(promise?: Promise<unknown>);
    get promise(): void | Promise<unknown>;
    get error(): Error;
    private wait;
    ok(): Promise<boolean>;
    message(): string | void;
    isNotFound(): boolean;
    isCorruption(): boolean;
    isIOError(): boolean;
    isNotSupportedError(): boolean;
    isInvalidArgument(): boolean;
}
export {};
