/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import Slice from "./Slice";
import { FileMetaData, GetStats } from "./VersionFormat";
import VersionSet from "./VersionSet";
import { InternalKey, InternalKeyComparator, LookupKey } from "./Format";
import Status from "./Status";
import { Comparator } from "./Comparator";
interface FileEntry {
    key: InternalKey;
    value: Slice;
}
export default class Version {
    static saveValue(saver: unknown, ikey: Slice, v: Slice): void;
    static levelFileNumIterator(icmp: InternalKeyComparator, // TODO used for seek
    files: FileMetaData[]): IterableIterator<FileEntry>;
    static afterFile(ucmp: Comparator, userKey: Slice, f: FileMetaData): boolean;
    static beforeFile(ucmp: Comparator, userKey: Slice, f: FileMetaData): boolean;
    versionSet: VersionSet;
    next: Version;
    prev: Version;
    refs: number;
    fileToCompact: FileMetaData;
    fileToCompactLevel: number;
    compactionScore: number;
    compactionLevel: number;
    files: FileMetaData[][];
    constructor(versionSet: VersionSet);
    ref(): void;
    unref(): void;
    get(lkey: LookupKey, stats: GetStats): Promise<Status>;
    forEachOverlapping(userKey: Slice, internalKey: Slice, arg: unknown, match: (arg: unknown, level: number, f: FileMetaData) => Promise<boolean>): Promise<void>;
    private someFileOverlapsRange;
    private findFile;
    overlapInLevel(level: number, smallestUserKey: Slice, largestUserKey: Slice): boolean;
    getOverlappingInputs(level: number, begin: InternalKey, end: InternalKey): FileMetaData[];
    pickLevelForMemTableOutput(minUserKey: Slice, maxUserKey: Slice): number;
    updateStats(stats: GetStats): boolean;
}
export {};
