/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { InternalKey } from "./Format";
import { CompactPointer, DeletedFile, NewFile } from "./VersionFormat";
export default class VersionEdit {
    compactPointers: CompactPointer[];
    deletedFiles: DeletedFile[];
    newFiles: NewFile[];
    private _comparator;
    private _logNumber?;
    private _prevLogNumber?;
    private _lastLogNumber?;
    private _lastSequence?;
    private _nextFileNumber?;
    private _hasComparator?;
    private _hasLogNumber?;
    private _hasPrevLogNumber?;
    private _hasNextFileNumber?;
    private _hasLastSequence?;
    constructor();
    clear(): void;
    set comparator(value: string);
    get comparator(): string;
    set logNumber(value: number);
    get logNumber(): number;
    set prevLogNumber(value: number);
    get prevLogNumber(): number;
    set nextFileNumber(value: number);
    get nextFileNumber(): number;
    set lastSequence(value: bigint);
    get lastSequence(): bigint;
    get hasComparator(): boolean;
    get hasLogNumber(): boolean;
    get hasPrevLogNumber(): boolean;
    get hasNextFileNumber(): boolean;
    get hasLastSequence(): boolean;
    deleteFile(level: number, fileNum: number): void;
    addFile(level: number, fileNum: number, fileSize: number, smallest: InternalKey, largest: InternalKey): void;
    setCompactPointer(level: number, internalKey: InternalKey): void;
}
