/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { Buffer } from "./Buffer";
import Slice from "./Slice";
import { VersionEditTag } from "./Format";
import VersionEdit from "./VersionEdit";
export default class VersionEditRecord {
    static from(buf: Buffer): VersionEditRecord;
    static add(edit: VersionEdit): Slice;
    static decode(opSlice: Slice): VersionEdit;
    constructor(type: VersionEditTag, data: Slice | Buffer);
    get length(): number;
    get size(): number;
    data: Slice;
    type: VersionEditTag;
    get buffer(): Buffer;
}
