/**
 * Copyright (c) 2018-present, heineiuo.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import { InternalKeyComparator, InternalKey } from "./Format";
import { Options } from "./Options";
export declare class FileMetaData {
    refs: number;
    allowedSeeks: number;
    fileSize: number;
    number: number;
    smallest: InternalKey;
    largest: InternalKey;
    constructor();
}
export declare class BySmallestKey {
    internalComparator: InternalKeyComparator;
    constructor(cmp?: InternalKeyComparator);
    operator(file1: FileMetaData, file2: FileMetaData): boolean;
}
export declare class FileSet {
    _set: FileMetaData[];
    compare: BySmallestKey;
    constructor(cmp: BySmallestKey);
    add(file: FileMetaData): void;
    iterator(): IterableIterator<FileMetaData>;
}
export declare type FileMetaDataLeveldb = {
    fileNum: number;
    fileSize: number;
    smallestKey: InternalKey;
    largestKey: InternalKey;
};
export declare type CompactPointer = {
    level: number;
    internalKey: InternalKey;
};
export declare type DeletedFile = {
    level: number;
    fileNum: number;
};
export declare type NewFile = {
    level: number;
    fileMetaData: FileMetaData;
};
export declare function getMaxBytesForLevel(level: number): number;
export declare function getExpandedCompactionByteSizeLimit(options: Options): number;
export interface GetStats {
    seekFile: FileMetaData;
    seekFileLevel: number;
}
