export declare class YallistNode<T = unknown> {
    constructor(value: T, prev: null | YallistNode<T>, next: null | YallistNode<T>, list: Yallist<T>);
    value: T;
    list: Yallist<T> | null;
    prev: YallistNode<T> | null;
    next: YallistNode<T> | null;
}
export declare class Yallist<T = unknown> {
    constructor();
    length: number;
    tail: null | YallistNode<T>;
    head: null | YallistNode<T>;
    push(item: T): number;
    unshift(item: T): number;
    unshiftNode(node: YallistNode<T>): void;
    removeNode(node: YallistNode<T>): YallistNode<T> | null;
    forEach(callbackFn: (value: T, index: number, list: this) => void): void;
    map(callbackFn: (value: T, list: this) => T): Yallist;
    toArray(): T[];
}
